## ros-galactic-performance-test 1.2.1

=== CMakeLists.txt ===

# Copyright 2017 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)
project(performance_test)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
include(compile_options)

set(OPTIONAL_AMENT_DEPENDENCES)
set(OPTIONAL_LIBRARIES)

# Default to C++14
set(CMAKE_CXX_STANDARD 14)
find_package(ament_cmake REQUIRED)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(PERFORMANCE_TEST_RT_ENABLED_DEFAULT ON)
  add_definitions(-DPERFORMANCE_TEST_LINUX)
else()
  set(PERFORMANCE_TEST_RT_ENABLED_DEFAULT OFF)
endif()
option(PERFORMANCE_TEST_RT_ENABLED
  "Enable options for thread and memory optimization. This may not build on all platforms"
  ${PERFORMANCE_TEST_RT_ENABLED_DEFAULT})

# Ensure we use the CMake support from ConnextDDS instead of the one provided
# with the installed RMW package.
# This change in the environment only affect to the CMake environment. The
# environment variable will remain as it is outside the building process.
if($ENV{RMW_IMPLEMENTATION})
  string(REPLACE
    "rmw_connext_cpp;"
    ""
    ENV{RMW_IMPLEMENTATION}
    $ENV{RMW_IMPLEMENTATION}
  )
  string(REPLACE
    "rmw_connext_cpp" # It can be alone, without other values
    ""
    ENV{RMW_IMPLEMENTATION}
    $ENV{RMW_IMPLEMENTATION}
  )
endif()

find_package(Threads REQUIRED)

find_package(ament_cmake REQUIRED)

find_package(osrf_testing_tools_cpp QUIET)
if(${osrf_testing_tools_cpp_FOUND})
    list(APPEND OPTIONAL_AMENT_DEPENDENCES "osrf_testing_tools_cpp")
    list(APPEND OPTIONAL_LIBRARIES osrf_testing_tools_cpp::memory_tools)
    add_definitions(-DPERFORMANCE_TEST_MEMORYTOOLS_ENABLED)
endif()

ament_export_include_directories(include)
ament_export_dependencies(rosidl_default_runtime)

# This is a workaround for broken include paths on some systems.
include_directories(${FastRTPS_INCLUDE_DIR} ${FastRTPS_INCLUDE_DIR}/fastrtps/include ${fastcdr_INCLUDE_DIR})
include_directories(include ${osrf_testing_tools_cpp_INCLUDE_DIR})


# ROS2 rclcpp plugins
option(PERFORMANCE_TEST_RCLCPP_ENABLED "" ON)
if(PERFORMANCE_TEST_RCLCPP_ENABLED)
  find_package(rclcpp REQUIRED)
  find_package(rmw REQUIRED)
  find_package(rosidl_default_generators REQUIRED)
  add_definitions(-DPERFORMANCE_TEST_RCLCPP_ENABLED)
  set(PERFORMANCE_TEST_RCLCPP_STE_ENABLED ON)
  set(PERFORMANCE_TEST_RCLCPP_ZERO_COPY_ENABLED ON)
  if($ENV{ROS_DISTRO} MATCHES "dashing")
    set(PERFORMANCE_TEST_RCLCPP_ZERO_COPY_ENABLED OFF)
  endif()
  if($ENV{ROS_DISTRO} MATCHES "foxy")
    set(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED ON)
  endif()
  if($ENV{ROS_DISTRO} MATCHES "galactic")
    set(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED ON)
    set(PERFORMANCE_TEST_RCLCPP_SSTE_ENABLED ON)
  endif()
  if($ENV{ROS_DISTRO} MATCHES "rolling")
    set(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED ON)
    set(PERFORMANCE_TEST_RCLCPP_SSTE_ENABLED ON)
  endif()
  if($ENV{ROS_DISTRO} MATCHES "humble")
    set(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED ON)
    set(PERFORMANCE_TEST_RCLCPP_SSTE_ENABLED ON)
  endif()
  if(PERFORMANCE_TEST_RCLCPP_STE_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_STE_ENABLED)
  endif()
  if(PERFORMANCE_TEST_RCLCPP_SSTE_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_SSTE_ENABLED)
  endif()
  if(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED)
  endif()
  if(PERFORMANCE_TEST_RCLCPP_ZERO_COPY_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_ZERO_COPY_ENABLED)
  endif()
endif()

# Apex.OS Waitset and Polling Subscription
option(PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED "Option to enable Polling Subscription Plugin.
  The plugin can only work if ApexOS is present, otherwise it will fail." OFF)

if(PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED)
  find_library(APEXCPP_LIB apexcpp)
  if(NOT APEXCPP_LIB)
    message(WARNING "ApexOSPollingSubscription not found, disabling")
    set(PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED OFF)
  else()
    find_package(rclcpp REQUIRED)
    find_package(rmw REQUIRED)
    find_package(rosidl_default_generators REQUIRED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_RCLCPP_ZERO_COPY_ENABLED)
    add_definitions(-DPERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED)
  endif()
endif()

option(APEX_CERT "Set to true if building against Apex.OS Cert" OFF)
if(APEX_CERT)
  add_definitions(-DAPEX_CERT)
endif()

# FastRTPS
option(PERFORMANCE_TEST_FASTRTPS_ENABLED "Enable FastRTPS" OFF)
if(PERFORMANCE_TEST_FASTRTPS_ENABLED)
  find_package(fastrtps_cmake_module QUIET REQUIRED)
  find_package(FastRTPS QUIET REQUIRED)
  add_definitions(-DPERFORMANCE_TEST_FASTRTPS_ENABLED)
  list(APPEND PLUGIN_LIBRARIES ${FastRTPS_LIBRARIES})
endif()


# ConnextDDS
option(PERFORMANCE_TEST_CONNEXTDDS_ENABLED "Enable Connext DDS Pro" OFF)
if(PERFORMANCE_TEST_CONNEXTDDS_ENABLED)
    # Append the path to CMAKE_MODULE_PATH in order to find the
    # FindConnextDDS.cmake CMake script
    set(CMAKE_MODULE_PATH
      ${CMAKE_MODULE_PATH}
      "$ENV{NDDSHOME}/resource/cmake"
    )

    find_package(RTIConnextDDS
      REQUIRED
      COMPONENTS
        core
    )
    add_definitions(-DPERFORMANCE_TEST_CONNEXTDDS_ENABLED)
endif()


# RTI Connext Micro
option(PERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED "Enable Connext DDS Micro" OFF)
if(PERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED)
  find_package(connext_micro_cmake_module REQUIRED)
  find_package(ConnextMicro MODULE REQUIRED)
  if(ConnextMicro_FOUND)
    add_definitions(-DPERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED)
    ament_export_definitions(${ConnextMicro_DEFINITIONS})
  endif()
endif()


if(PERFORMANCE_TEST_CONNEXTDDS_ENABLED AND PERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED)
  message(FATAL_ERROR
    "ConnextDDS Pro and ConnextDDS Micro cannot be used in the same "
    "application. Please, disable one")
endif()


# CycloneDDS
option(PERFORMANCE_TEST_CYCLONEDDS_ENABLED "Enable CycloneDDS" OFF)
if(PERFORMANCE_TEST_CYCLONEDDS_ENABLED)
  find_package(CycloneDDS REQUIRED COMPONENTS idlc)
  add_definitions(-DPERFORMANCE_TEST_CYCLONEDDS_ENABLED)
  list(APPEND PLUGIN_LIBRARIES CycloneDDS::ddsc)
endif()

# cyclonedds-cxx
option(PERFORMANCE_TEST_CYCLONEDDS_CXX_ENABLED "Enable C++ binding for Cyclone DDS" OFF)
if(PERFORMANCE_TEST_CYCLONEDDS_CXX_ENABLED)
  find_package(CycloneDDS-CXX REQUIRED)
  add_definitions(-DPERFORMANCE_TEST_CYCLONEDDS_CXX_ENABLED)
  list(APPEND PLUGIN_LIBRARIES cyclonedds_cxx_idl CycloneDDS-CXX::ddscxx)
endif()

# iceoryx
option(PERFORMANCE_TEST_ICEORYX_ENABLED "Require iceoryx to be available, fail otherwise" OFF)
if(PERFORMANCE_TEST_ICEORYX_ENABLED)
  find_package(iceoryx_posh CONFIG REQUIRED)
  add_definitions(-DPERFORMANCE_TEST_ICEORYX_ENABLED)
  list(APPEND PLUGIN_LIBRARIES iceoryx_posh::iceoryx_posh)
endif()


# OpenDDS
option(PERFORMANCE_TEST_OPENDDS_ENABLED "Require Open DDS to be available, fail otherwise" OFF)
if(PERFORMANCE_TEST_OPENDDS_ENABLED)
  add_definitions(-DPERFORMANCE_TEST_OPENDDS_ENABLED)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()


add_subdirectory(msg)
include_directories(${IDLGEN_INCLUDE_DIR})

if(PERFORMANCE_TEST_RCLCPP_ENABLED OR PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED)
  # rosidl_generate_interfaces must be invoked from this CMakeLists.txt file. Otherwise, the
  # generated messages are placed in a directory where ros1_bridge can not find them.
  rosidl_generate_interfaces(${PROJECT_NAME} ${ROSIDL_GEN_LIST})
endif()


set(sources
    src/main.cpp
    src/communication_abstractions/communicator.cpp
    src/communication_abstractions/communicator.hpp
    src/communication_abstractions/resource_manager.cpp
    src/communication_abstractions/resource_manager.hpp
    src/outputs/stdout_output.cpp
    src/outputs/csv_output.cpp
    src/outputs/json_output.cpp
    src/data_running/data_publisher.hpp
    src/data_running/data_subscriber.hpp
    src/data_running/data_entity.hpp
    src/data_running/data_entity_factory.cpp
    src/data_running/data_entity_factory.hpp
    src/experiment_execution/analysis_result.cpp
    src/experiment_execution/analysis_result.hpp
    src/experiment_execution/runner.hpp
    src/experiment_execution/data_stats.hpp
    src/experiment_execution/run_type.hpp
    src/experiment_configuration/communication_mean.cpp
    src/experiment_configuration/communication_mean.hpp
    src/experiment_configuration/qos_abstraction.cpp
    src/experiment_configuration/qos_abstraction.hpp
    src/experiment_configuration/experiment_configuration.cpp
    src/experiment_configuration/experiment_configuration.hpp
    src/experiment_configuration/external_info_storage.cpp
    src/experiment_configuration/external_info_storage.hpp
    src/utilities/spin_lock.hpp
    src/utilities/statistics_tracker.hpp
    src/utilities/cpu_usage_tracker.hpp
    src/utilities/qnx_res_usage.hpp
    src/utilities/json_logger.hpp
)

if(PERFORMANCE_TEST_RT_ENABLED)
  add_definitions(-DPERFORMANCE_TEST_RT_ENABLED)
  list(APPEND sources src/utilities/rt_enabler.hpp)
endif()

if(PERFORMANCE_TEST_RCLCPP_ENABLED)
  list(APPEND sources src/communication_abstractions/rclcpp_communicator.hpp)
  list(APPEND sources src/communication_abstractions/rclcpp_callback_communicator.hpp)
endif()

if(PERFORMANCE_TEST_RCLCPP_STE_ENABLED)
  list(APPEND sources src/data_running/factories/rclcpp_ste_data_runner_factory.cpp)
  list(APPEND sources src/data_running/factories/rclcpp_ste_data_runner_factory.hpp)
endif()

if(PERFORMANCE_TEST_RCLCPP_SSTE_ENABLED)
  list(APPEND sources src/data_running/factories/rclcpp_sste_data_runner_factory.cpp)
  list(APPEND sources src/data_running/factories/rclcpp_sste_data_runner_factory.hpp)
endif()

if(PERFORMANCE_TEST_RCLCPP_WAITSET_ENABLED)
  list(APPEND sources src/communication_abstractions/rclcpp_waitset_communicator.hpp)
  list(APPEND sources src/data_running/factories/rclcpp_waitset_data_runner_factory.cpp)
  list(APPEND sources src/data_running/factories/rclcpp_waitset_data_runner_factory.hpp)
endif()

if(PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED)
  list(APPEND sources src/communication_abstractions/apex_os_polling_subscription_communicator.hpp)
endif()

if(PERFORMANCE_TEST_FASTRTPS_ENABLED)
  list(APPEND sources src/communication_abstractions/fast_rtps_communicator.hpp)
endif()

if(PERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED)
  list(APPEND sources src/communication_abstractions/connext_dds_micro_communicator.hpp)
endif()

if(PERFORMANCE_TEST_CYCLONEDDS_ENABLED)
  list(APPEND sources src/communication_abstractions/cyclonedds_communicator.hpp)
endif()

if(PERFORMANCE_TEST_CYCLONEDDS_CXX_ENABLED)
  list(APPEND sources src/communication_abstractions/cyclonedds_cxx_communicator.hpp)
endif()

if(PERFORMANCE_TEST_ICEORYX_ENABLED)
  list(APPEND sources src/communication_abstractions/iceoryx_communicator.hpp)
endif()

if(PERFORMANCE_TEST_OPENDDS_ENABLED)
  list(APPEND sources src/communication_abstractions/opendds_communicator.hpp)
endif()

include(ExternalProject)

set(EXTERNAL_INSTALL_LOCATION ${CMAKE_BINARY_DIR}/external)
externalproject_add(
  tclap
  GIT_REPOSITORY http://git.code.sf.net/p/tclap/code
  GIT_TAG 1.4.0-rc1
  GIT_SHALLOW TRUE
  PREFIX ${EXTERNAL_INSTALL_LOCATION}
  SOURCE_DIR ${EXTERNAL_INSTALL_LOCATION}/tclap
  CMAKE_COMMAND ""
  CONFIGURE_COMMAND ""
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
)
include_directories(SYSTEM ${EXTERNAL_INSTALL_LOCATION}/tclap/include)

externalproject_add(
  rapidjson

=== msg/CMakeLists.txt ===
# Copyright 2021 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SUPPLEMENTAL_IDL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/FixedHeader.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/FixedPointField.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/FixedTime.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/NavSatStatus.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Point.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Point32.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Polygon.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Vector3.idl
)

set(SUPPORTED_IDL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/Array1k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array4k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array16k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array32k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array60k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array64k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array256k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array1m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array2m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array4m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Array8m.idl

    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence1k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence4k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence16k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence32k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence64k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence256k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence1m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence2m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence4m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence8m.idl

    ${CMAKE_CURRENT_SOURCE_DIR}/Struct16.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Struct256.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Struct4k.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Struct32k.idl

    ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud1m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud2m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud4m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud8m.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud512k.idl

    ${CMAKE_CURRENT_SOURCE_DIR}/NavSatFix.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/RadarDetection.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/RadarTrack.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/Range.idl
)

# TODO(erik.snider) remove this when we reduce the template expansion in the communicator factory
option(PERFORMANCE_TEST_MINIMAL_MESSAGES
  "Include only a small subset of messages, for quick compilation of smoke tests" OFF)
if(PERFORMANCE_TEST_MINIMAL_MESSAGES)
  set(SUPPORTED_IDL_FILES
      ${CMAKE_CURRENT_SOURCE_DIR}/Array16k.idl
      ${CMAKE_CURRENT_SOURCE_DIR}/Array1m.idl

      ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence16k.idl
      ${CMAKE_CURRENT_SOURCE_DIR}/BoundedSequence1m.idl

      ${CMAKE_CURRENT_SOURCE_DIR}/PointCloud1m.idl
  )
endif()

if(NOT APEX_CERT)
  list(APPEND SUPPORTED_IDL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/UnboundedSequence.idl
    ${CMAKE_CURRENT_SOURCE_DIR}/UnboundedString.idl
  )
endif()

set(IDL_FILES ${SUPPLEMENTAL_IDL_FILES} ${SUPPORTED_IDL_FILES})

set(GENERATED_MESSAGES_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/gen/message")
list(APPEND IDLGEN_INCLUDE_DIR ${GENERATED_MESSAGES_INCLUDE_DIR})
file(MAKE_DIRECTORY "${GENERATED_MESSAGES_INCLUDE_DIR}/performance_test/generated_messages")

set(CMAKE_MESSAGE_CLASS_TYPES "// Generated message classes")
set(CMAKE_MESSAGE_INCLUDE_STATEMENTS "// Generated message files")
foreach(idl ${SUPPORTED_IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})
  set(CMAKE_MESSAGE_NAME ${basename})

  # if a lower case letter is followed by an uper case letter, split them with an underscore
  string(REGEX REPLACE "([a-z])([A-Z])" "\\1_\\2" CMAKE_MESSAGE_SNAKE_NAME "${CMAKE_MESSAGE_NAME}")
  string(TOLOWER "${CMAKE_MESSAGE_SNAKE_NAME}" CMAKE_MESSAGE_SNAKE_NAME)

  set(CMAKE_MESSAGE_HEADER_FILE "performance_test/generated_messages/${CMAKE_MESSAGE_SNAKE_NAME}.hpp")

  configure_file(message_file.hpp.in "${GENERATED_MESSAGES_INCLUDE_DIR}/${CMAKE_MESSAGE_HEADER_FILE}")

  set(CMAKE_MESSAGE_INCLUDE_STATEMENTS "${CMAKE_MESSAGE_INCLUDE_STATEMENTS}\n#include <${CMAKE_MESSAGE_HEADER_FILE}>")
  set(CMAKE_MESSAGE_CLASS_TYPES "${CMAKE_MESSAGE_CLASS_TYPES},\n${CMAKE_MESSAGE_NAME}")
endforeach()

configure_file(messages.hpp.in "${GENERATED_MESSAGES_INCLUDE_DIR}/performance_test/generated_messages/messages.hpp")

if(PERFORMANCE_TEST_FASTRTPS_ENABLED)
  add_subdirectory(fast_rtps)
  list(APPEND IDLGEN_INCLUDE_DIR ${FAST_RTPS_IDL_INCLUDE_DIR})
  list(APPEND IDLGEN_LIBRARIES fast_rtps_idl fastcdr)
endif()

if(PERFORMANCE_TEST_CONNEXTDDS_ENABLED)
  add_subdirectory(connextdds)
  list(APPEND IDLGEN_LIBRARIES rti_connextdds_idl)
endif()

if(PERFORMANCE_TEST_CONNEXTDDSMICRO_ENABLED)
  # There's nothing here to generate the messages from the IDL files, but Apex.AI
  # is unable to add or test the correct code without an RTI Connext Micro license.
  # add_subdirectory(connextdds_micro)
  # list(APPEND IDLGEN_INCLUDE_DIR ${RTI_MICRO_IDL_INCLUDE_DIR})
endif()

if(PERFORMANCE_TEST_CYCLONEDDS_ENABLED)
  add_subdirectory(cyclonedds)
  list(APPEND IDLGEN_INCLUDE_DIR ${CYCLONEDDS_IDL_INCLUDE_DIR})
  list(APPEND IDLGEN_LIBRARIES cyclonedds_idl)
endif()

if(PERFORMANCE_TEST_CYCLONEDDS_CXX_ENABLED)
  add_subdirectory(cyclonedds-cxx)
  list(APPEND IDLGEN_INCLUDE_DIR ${CYCLONEDDS_CXX_IDL_INCLUDE_DIR})
  list(APPEND IDLGEN_LIBRARIES cyclonedds_cxx_idl)
endif()

if(PERFORMANCE_TEST_ICEORYX_ENABLED)
  if(NOT PERFORMANCE_TEST_RCLCPP_ENABLED)
    message(FATAL_ERROR
    "The iceoryx plugin depends on the rosidl generated messages. "
    "ROS2 must be installed in your environment, and "
    "PERFORMANCE_TEST_RCLCPP_ENABLED must be ON.")
  endif()
endif()

if(PERFORMANCE_TEST_OPENDDS_ENABLED)
  add_subdirectory(opendds)
  list(APPEND IDLGEN_INCLUDE_DIR ${OPENDDS_IDL_INCLUDE_DIR} ${PARENT_DDS_ROOT_INCLUDE})

  set(DDS_DYN_LIBS  ${PARENT_DDS_ROOT_LIBS}/libACE.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO.so
                    ${PARENT_DDS_ROOT_LIBS}/libOpenDDS_Dcps.so
                    ${PARENT_DDS_ROOT_LIBS}/libOpenDDS_Rtps.so
                    ${PARENT_DDS_ROOT_LIBS}/libOpenDDS_Rtps_Udp.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_PortableServer.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_PortableServer.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_PI.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_CodecFactory.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_AnyTypeCode.so
                    ${PARENT_DDS_ROOT_LIBS}/libTAO_BiDirGIOP.so)
  list(APPEND IDLGEN_LIBRARIES opendds_idl ${DDS_DYN_LIBS})
endif()

if(PERFORMANCE_TEST_RCLCPP_ENABLED OR PERFORMANCE_TEST_APEX_OS_POLLING_SUBSCRIPTION_ENABLED)
  add_subdirectory(rclcpp)
  set(ROSIDL_GEN_LIST ${ROSIDL_GEN_LIST} PARENT_SCOPE)
endif()

set(IDLGEN_INCLUDE_DIR ${IDLGEN_INCLUDE_DIR} PARENT_SCOPE)
set(IDLGEN_LIBRARIES ${IDLGEN_LIBRARIES} PARENT_SCOPE)

=== msg/connextdds/CMakeLists.txt ===
# (c) 2020 Copyright, Real-Time Innovations, Inc. All rights reserved.
# RTI grants Licensee a license to use, modify, compile, and create derivative
# works of the Software.  Licensee has the right to distribute object form only
# for use with RTI products. The Software is provided "as is", with no warranty
# of any type, including any warranty for fitness for any purpose. RTI is under
# no obligation to maintain or support the Software. RTI shall not be liable for
# any incidental or consequential damages arising out of the use or inability to
# use the software.

###############################################
# Module to build the ConnextDDS communicator #
###############################################

# Function to generate the source files from the IDL files
# Parameters:
#   - IDL_FILE: path to the IDL file
#   - OUTPUT_DIR: where the code should be generated
#
# Output:
#   - idl_<IDL Name>__connextdds_sources target: CMake target to generate
#   the source code needed from the IDL file.
#   - GENERATED_CXX_FILES: list of the C++ source files that will be generated
function(connextdds_run_codegen)
    set(options)
    set(single_value_args IDL_FILE OUTPUT_DIR)
    set(multi_value_args)
    cmake_parse_arguments(_CONNEXTDDS
        "${options}"
        "${single_value_args}"
        "${multi_value_args}"
        ${ARGN}
    )

    # Get the files to be generated by Codegen
    get_filename_component(filename ${_CONNEXTDDS_IDL_FILE} NAME)
    string(REGEX REPLACE "\\.idl" "" idl_name ${filename})

    # Source files to be generated
    set(GENERATED_CXX_FILES
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}.cxx"
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}Plugin.cxx"
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}Support.cxx"
    )

    # Header files to be generated
    set(GENERATED_HEADER_FILES
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}.h"
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}Plugin.h"
        "${_CONNEXTDDS_OUTPUT_DIR}/${idl_name}Support.h"
    )

    set(GENERATED_FILES
        ${GENERATED_CXX_FILES}
        ${GENERATED_HEADER_FILES}
    )

    # Create a target to generate the source files
    # Instead of creating here the source files using the COMMAND parameter
    # from add_custom_target, we create a CMake custom command. The reason is
    # the COMMAND from add_custom_target will be executed always and the
    # custom command will be executed only if the IDL file was modified
    add_custom_target(idl_${idl_name}_connextdds_sources
        MAIN_DEPENDENCY
            ${GENERATED_FILES}
    )

    # Command to create the source files
    add_custom_command(
        OUTPUT
            ${GENERATED_FILES}
        COMMAND
            ${RTICODEGEN}
                -language C++
                -replace
                -d ${_CONNEXTDDS_OUTPUT_DIR}
                ${_CONNEXTDDS_IDL_FILE}
        COMMENT "Generating the type for ${idl_name}"
        MAIN_DEPENDENCY
            ${_CONNEXTDDS_IDL_FILE}
        VERBATIM
    )

    set(GENERATED_CXX_FILES ${GENERATED_CXX_FILES} PARENT_SCOPE)
endfunction()

# Where RTI Codegenerator is located
set(RTICODEGEN "${CONNEXTDDS_DIR}/bin/rtiddsgen")
if(WIN32)
    set(RTICODEGEN "${RTICODEGEN}.bat")
endif()


set(IDL_GEN_ROOT "${CMAKE_CURRENT_BINARY_DIR}/gen/connextdds")
file(MAKE_DIRECTORY ${IDL_GEN_ROOT})

set(IDL_GEN_CXX_LIST)
foreach(idl ${IDL_FILES})
    get_filename_component(filename ${idl} NAME)

    file(READ ${idl} filedata)
    string(REGEX REPLACE "__plugin__" "ConnextDDSGen" filedata "${filedata}")
    file(WRITE ${IDL_GEN_ROOT}/${filename} "${filedata}")

    connextdds_run_codegen(
        IDL_FILE ${IDL_GEN_ROOT}/${filename}
        OUTPUT_DIR ${IDL_GEN_ROOT}
    )

    list(APPEND IDL_GEN_CXX_LIST ${GENERATED_CXX_FILES})
endforeach()

# Create a library with all the source code from the types
add_library(rti_connextdds_idl
    ${IDL_GEN_CXX_LIST}
)

# Force the output directory for the library
set(output_dir "${CMAKE_CURRENT_BINARY_DIR}/objs/${CONNEXTDDS_ARCH}")
set_target_properties(rti_connextdds_idl
    PROPERTIES
        ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${output_dir}
        ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${output_dir}
        ARCHIVE_OUTPUT_DIRECTORY ${output_dir}
        LIBRARY_OUTPUT_DIRECTORY_RELEASE ${output_dir}
        LIBRARY_OUTPUT_DIRECTORY_DEBUG ${output_dir}
        LIBRARY_OUTPUT_DIRECTORY ${output_dir}
        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${output_dir}
        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${output_dir}
        RUNTIME_OUTPUT_DIRECTORY ${output_dir}
)

set(lib_type "RELEASE")
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(lib_type "DEBUG")
endif()

# Link the ConnextDDS libraries
target_link_libraries(rti_connextdds_idl
    PUBLIC
        ${CONNEXTDDS_C_API_LIBRARIES_${lib_type}_SHARED}
        ${CONNEXTDDS_CPP_API_LIBRARIES_${lib_type}_SHARED}
        ${CONNEXTDDS_EXTERNAL_LIBS}
)

# Include the ConnextDDS directories and the header files from the generated
# code
target_include_directories(rti_connextdds_idl
    PUBLIC
        ${CONNEXTDDS_INCLUDE_DIRS}
        ${IDL_GEN_ROOT}/..
)

# The variable that contains the definitions was changed in ConnextDDS 6.0.0
# Also, this change is needed to avoid a bug that affects the find package
# CMake script of Connext DDS 5.3.1
if(RTICONNEXTDDS_VERSION VERSION_LESS "6.0.0")
    # This will just affect to architectures using GCC in systems of 32 or 64
    # bits
    string(REPLACE "-m64 " ""
        FIXED_CONNEXTDDS_DEFINITIONS
        "${CONNEXTDDS_DEFINITIONS}"
    )
    string(REPLACE "-m32 " ""
        FIXED_CONNEXTDDS_DEFINITIONS
        "${FIXED_CONNEXTDDS_DEFINITIONS}"
    )
else()
    set(FIXED_CONNEXTDDS_DEFINITIONS ${CONNEXTDDS_COMPILE_DEFINITIONS})
endif()

# Compile definitions for the library
target_compile_definitions(rti_connextdds_idl
    PUBLIC
        ${FIXED_CONNEXTDDS_DEFINITIONS}
)

=== msg/cyclonedds-cxx/CMakeLists.txt ===
# Copyright 2021 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(IDL_GEN_ROOT ${CMAKE_CURRENT_BINARY_DIR}/gen/cyclonedds-cxx)

file(MAKE_DIRECTORY ${IDL_GEN_ROOT})

foreach(idl ${IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})

  file(READ ${idl} filedata)
  string(REGEX REPLACE "__plugin__" "CycloneDDSCXXGen" filedata "${filedata}")
  file(WRITE ${IDL_GEN_ROOT}/${filename} "${filedata}")


  set(IDL_GEN_HPP ${IDL_GEN_ROOT}/${basename}.hpp)
  set(IDL_GEN_CPP ${IDL_GEN_ROOT}/${basename}.cpp)

  add_custom_command(
    OUTPUT   ${IDL_GEN_HPP} ${IDL_GEN_CPP}
    COMMAND  CycloneDDS::idlc
    ARGS     -l $<TARGET_FILE:CycloneDDS-CXX::idlcxx> -fcase-sensitive -fkeylist ${IDL_GEN_ROOT}/${filename}
    DEPENDS  ${IDL_GEN_ROOT}/${filename} CycloneDDS::idlc CycloneDDS-CXX::idlcxx
    COMMENT  "Generating C++ typesupport for ${idl}"
    WORKING_DIRECTORY ${IDL_GEN_ROOT}
    VERBATIM)
  set_source_files_properties(${IDL_GEN_HPP} ${IDL_GEN_CPP} PROPERTIES GENERATED 1)
  list(APPEND IDL_GEN_HPP_LIST ${IDL_GEN_HPP})
  list(APPEND IDL_GEN_CPP_LIST ${IDL_GEN_CPP})
endforeach()

add_custom_target(cyclonedds_cxx_idl_generate DEPENDS ${IDL_GEN_HPP_LIST})
add_library(cyclonedds_cxx_idl STATIC ${IDL_GEN_HPP_LIST} ${IDL_GEN_CPP_LIST})
target_link_libraries(cyclonedds_cxx_idl CycloneDDS-CXX::ddscxx)
target_include_directories(cyclonedds_cxx_idl INTERFACE ${IDL_GEN_ROOT}/..)
add_dependencies(cyclonedds_cxx_idl cyclonedds_cxx_idl_generate)

set(CYCLONEDDS_CXX_IDL_INCLUDE_DIR ${IDL_GEN_ROOT}/.. PARENT_SCOPE)

=== msg/cyclonedds/CMakeLists.txt ===
# Copyright 2017 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)

set(IDL_GEN_ROOT ${CMAKE_CURRENT_BINARY_DIR}/gen/cyclonedds)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})

file(MAKE_DIRECTORY ${IDL_GEN_ROOT})

foreach(idl ${IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})

  file(READ ${idl} filedata)
  string(REGEX REPLACE "__plugin__" "CycloneDDSGen" filedata "${filedata}")
  file(WRITE ${IDL_GEN_ROOT}/${filename} "${filedata}")
  file(APPEND ${IDL_GEN_ROOT}/${filename}
    "#pragma keylist performance_test::msg::CycloneDDSGen::${basename}\n")


  set(IDL_GEN_C ${IDL_GEN_ROOT}/${basename}.c)
  set(IDL_GEN_H ${IDL_GEN_ROOT}/${basename}.h)

  add_custom_command(
    OUTPUT   ${IDL_GEN_C} ${IDL_GEN_H}
    COMMAND  CycloneDDS::idlc
    ARGS     -fcase-sensitive -fkeylist ${IDL_GEN_ROOT}/${filename}
    DEPENDS  ${IDL_GEN_ROOT}/${filename}
    COMMENT  "Running idlc on ${FIL}"
    WORKING_DIRECTORY ${IDL_GEN_ROOT}
    VERBATIM)
  set_source_files_properties(${IDL_GEN_C} ${IDL_GEN_H} PROPERTIES GENERATED 1)
  list(APPEND IDL_GEN_H_LIST ${IDL_GEN_H})
  list(APPEND IDL_GEN_C_LIST ${IDL_GEN_C})
endforeach()

add_library(cyclonedds_idl ${IDL_GEN_H_LIST} ${IDL_GEN_C_LIST})

get_target_property(cdds_include_dir CycloneDDS::ddsc INTERFACE_INCLUDE_DIRECTORIES)
include_directories("${cdds_include_dir}")

set_compile_options(cyclonedds_idl)
target_compile_options(cyclonedds_idl BEFORE PRIVATE -fvisibility=default)
set(CYCLONEDDS_IDL_INCLUDE_DIR ${IDL_GEN_ROOT}/.. PARENT_SCOPE)

=== msg/fast_rtps/CMakeLists.txt ===
# Copyright 2017 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SOURCE_EXTENSION cxx)
find_package(rmw REQUIRED)
find_package(FastRTPS REQUIRED)
include_directories(${FastRTPS_INCLUDE_DIR} ${fastcdr_INCLUDE_DIR})
# This is a workaround for broken include paths on some systems.
include_directories(${FastRTPS_INCLUDE_DIR}/fastrtps/include ${fastcdr_INCLUDE_DIR})
set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)

set(IDL_GEN_ROOT ${CMAKE_CURRENT_BINARY_DIR}/gen/fast_rtps)
file(MAKE_DIRECTORY ${IDL_GEN_ROOT})

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/objs/${RTIME_TARGET_NAME})

find_program(FASTRTPS_BIN "fastrtpsgen")
if(NOT FASTRTPS_BIN)
  message(WARNING "Could not find program 'fastrtpsgen' in path. Trying to use bundled version")
  find_program(FASTRTPS_BIN "fastrtpsgen" PATHS "${PROJECT_SOURCE_DIR}/bin")
  if(NOT FASTRTPS_BIN)
    message(FATAL_ERROR "Could not find program 'fastrtpsgen'")
  endif()
endif()

foreach(idl ${IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})

  file(READ ${idl} filedata)
  string(REGEX REPLACE "__plugin__" "FastDDSGen" filedata "${filedata}")
  file(WRITE ${IDL_GEN_ROOT}/${filename} "${filedata}")

  set(IDL_GEN_C ${IDL_GEN_ROOT}/${basename}.${SOURCE_EXTENSION}
      ${IDL_GEN_ROOT}/${basename}PubSubTypes.${SOURCE_EXTENSION})

  set(IDL_GEN_H ${IDL_GEN_ROOT}/${basename}.h
      ${IDL_GEN_ROOT}/${basename}PubSubTypes.h)

  set(IDL_GEN_SS ${IDL_GEN_ROOT}/${basename}PubSubTypes.h)

  add_custom_command(OUTPUT ${IDL_GEN_SS}
      COMMAND ${FASTRTPS_BIN}
      -replace
      -d ${IDL_GEN_ROOT}
      ${IDL_GEN_ROOT}/${filename}
      DEPENDS ${IDL_GEN_ROOT}/${filename}
      WORKING_DIRECTORY ${IDL_GEN_ROOT}
      COMMENT "Regeneration type support plugin from ${idl}" VERBATIM)
  set_source_files_properties(${IDL_GEN_C} ${IDL_GEN_H} PROPERTIES GENERATED 1)

  list(APPEND IDL_GEN_H_LIST ${IDL_GEN_H})
  list(APPEND IDL_GEN_C_LIST ${IDL_GEN_C})

endforeach()

add_library(fast_rtps_idl
    ${IDL_GEN_H_LIST} ${IDL_GEN_C_LIST} ${FastRTPS_LIBRARIES})
set_compile_options(fast_rtps_idl)
set(FAST_RTPS_IDL_INCLUDE_DIR ${IDL_GEN_ROOT}/.. PARENT_SCOPE)

=== msg/opendds/CMakeLists.txt ===
# Copyright 2017 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http:#www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SOURCE_EXTENSION cpp)

set(DDS_ROOT /opt/opendds/share/dds)
set(ACE_ROOT ${DDS_ROOT}/../ace)
set(MPC_ROOT ${DDS_ROOT}/MPC)
set(TAO_ROOT ${DDS_ROOT}/../tao)

set(TAO_IDL
  DDS_ROOT=${DDS_ROOT}
  ACE_ROOT=${ACE_ROOT}
  TAO_ROOT=${TAO_ROOT}
  MPC_ROOT=${MPC_ROOT}
  LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):${ACE_ROOT}/lib:${DDS_ROOT}/lib ${ACE_ROOT}/bin/tao_idl)
set(OPENDDS_IDL
  DDS_ROOT=${DDS_ROOT}
  ACE_ROOT=${ACE_ROOT}
  TAO_ROOT=${TAO_ROOT}
  MPC_ROOT=${MPC_ROOT}
  LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):${ACE_ROOT}/lib:${DDS_ROOT}/lib ${DDS_ROOT}/bin/opendds_idl)
set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)

set(IDL_GEN_ROOT ${CMAKE_CURRENT_BINARY_DIR}/gen/opendds)

file(MAKE_DIRECTORY ${IDL_GEN_ROOT})

if(${CMAKE_BUILD_TYPE} MATCHES "[Rr]elease")
  add_definitions(-DNDEBUG)
endif()

link_directories(${DDS_ROOT}/../../lib)
include_directories(${IDL_GEN_ROOT} ${DDS_ROOT}/../../include/)

foreach(idl ${IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})

  file(READ ${idl} filedata)
  string(REGEX REPLACE "__plugin__" "OpenDDSGen" filedata "${filedata}")
  file(WRITE ${IDL_GEN_ROOT}/${filename} "${filedata}")
  file(APPEND ${IDL_GEN_ROOT}/${filename}
    "#pragma DCPS_DATA_TYPE \"performance_test::msg::OpenDDSGen::${basename}\"\n")

  set(TAO_IDL_GEN_CPP ${IDL_GEN_ROOT}/${basename}C.${SOURCE_EXTENSION}
          ${IDL_GEN_ROOT}/${basename}S.${SOURCE_EXTENSION}
          ${IDL_GEN_ROOT}/${basename}C.inl)

  set(TAO_IDL_GEN_H ${IDL_GEN_ROOT}/${basename}C.h
          ${IDL_GEN_ROOT}/${basename}S.h)

  set(TAO_IDL_GEN_CPP_SND_STG ${IDL_GEN_ROOT}/${basename}TypeSupportC.${SOURCE_EXTENSION}
                                    ${IDL_GEN_ROOT}/${basename}TypeSupportS.${SOURCE_EXTENSION}
                                    ${IDL_GEN_ROOT}/${basename}TypeSupportC.inl)

  set(TAO_IDL_GEN_H_SCD_STG  ${IDL_GEN_ROOT}/${basename}TypeSupportC.h
                                  ${IDL_GEN_ROOT}/${basename}TypeSupportS.h)

  set(OPENDDS_IDL_GEN_CPP ${IDL_GEN_ROOT}/${basename}TypeSupportImpl.${SOURCE_EXTENSION})

  set(OPENDDS_IDL_GEN_H ${IDL_GEN_ROOT}/${basename}TypeSupportImpl.h)

  add_custom_command(OUTPUT ${TAO_IDL_GEN_CPP} ${TAO_IDL_GEN_H}
          COMMAND ${TAO_IDL} -Cw -Sa -St -o ${IDL_GEN_ROOT} -I${IDL_GEN_ROOT} ${IDL_GEN_ROOT}/${filename}
          DEPENDS ${IDL_GEN_ROOT}/${filename}
          COMMENT "Regeneration type support plugin from ${idl}")

  add_custom_command(OUTPUT ${OPENDDS_IDL_GEN_CPP}
          ${OPENDDS_IDL_GEN_H} ${IDL_GEN_ROOT}/${basename}TypeSupport.idl
          COMMAND ${OPENDDS_IDL} -Cw -Sa -St -o ${IDL_GEN_ROOT} -I${IDL_GEN_ROOT} ${IDL_GEN_ROOT}/${filename}
          DEPENDS ${IDL_GEN_ROOT}/${filename}
          COMMENT "Regeneration type support plugin from ${idl}")

  add_custom_command(OUTPUT ${TAO_IDL_GEN_CPP_SND_STG} ${TAO_IDL_GEN_H_SCD_STG}
          COMMAND ${TAO_IDL} -Cw -Sa -St -o
            ${IDL_GEN_ROOT}
            -I${IDL_GEN_ROOT}
            -I${DDS_ROOT}/../../include/tao
            -I${DDS_ROOT}/../../include/
            ${IDL_GEN_ROOT}/${basename}TypeSupport.idl
          DEPENDS ${IDL_GEN_ROOT}/${basename}TypeSupport.idl
          COMMENT "Regeneration type support plugin from ${idl}")

  set_source_files_properties(${TAO_IDL_GEN_CPP} ${TAO_IDL_GEN_H} PROPERTIES GENERATED 1)
  set_source_files_properties(${OPENDDS_IDL_GEN_CPP} ${OPENDDS_IDL_GEN_H} PROPERTIES GENERATED 1)
  set_source_files_properties(${TAO_IDL_GEN_CPP_SND_STG} ${TAO_IDL_GEN_H_SCD_STG} PROPERTIES GENERATED 1)
  list(APPEND IDL_GEN_H_LIST ${TAO_IDL_GEN_H} ${OPENDDS_IDL_GEN_H} ${TAO_IDL_GEN_H_SCD_STG})
  list(APPEND IDL_GEN_C_LIST ${TAO_IDL_GEN_CPP} ${OPENDDS_IDL_GEN_CPP} ${TAO_IDL_GEN_CPP_SND_STG})

endforeach()

add_library(opendds_idl
        ${IDL_GEN_H_LIST} ${IDL_GEN_C_LIST})
set_compile_options(opendds_idl)
set(OPENDDS_IDL_INCLUDE_DIR ${IDL_GEN_ROOT}/.. PARENT_SCOPE)
set(PARENT_DDS_ROOT_INCLUDE ${DDS_ROOT}/../../include PARENT_SCOPE)
set(PARENT_DDS_ROOT_LIBS ${DDS_ROOT}/../../lib PARENT_SCOPE)

=== msg/rclcpp/CMakeLists.txt ===
set(IDL_GEN_ROOT ${CMAKE_BINARY_DIR}/gen/rosidl)
file(MAKE_DIRECTORY "${IDL_GEN_ROOT}/msg")
foreach(idl ${IDL_FILES})
  get_filename_component(filename ${idl} NAME)
  string(REGEX REPLACE "\\.idl" "" basename ${filename})
  set(output_file "${IDL_GEN_ROOT}/msg/${filename}")

  file(READ ${idl} filedata)
  string(REGEX REPLACE "module __plugin__ {" "" filedata "${filedata}")
  string(REGEX REPLACE "}; // __plugin__" "" filedata "${filedata}")
  string(REGEX REPLACE "__plugin__::" "" filedata "${filedata}")
  string(REGEX REPLACE "#include \"" "#include \"performance_test/msg/" filedata "${filedata}")
  file(WRITE ${output_file} "${filedata}")

  list(APPEND ROSIDL_GEN_LIST "${IDL_GEN_ROOT}:msg/${filename}")
endforeach()

# If we ever drop the ros1_bridge packages, just directly invoke
# rosidl_generate_interfaces(${PROJECT_NAME} ${ROSIDL_GEN_LIST})
# instead of bubbling the ROSIDL_GEN_LIST all the way up
set(ROSIDL_GEN_LIST ${ROSIDL_GEN_LIST} PARENT_SCOPE)

=== debian/changelog ===
ros-galactic-performance-test (1.2.1-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Apex AI, Inc. <opensource@apex.ai>  Thu, 30 Jun 2022 21:56:29 -0000

=== debian/control ===
Source: ros-galactic-performance-test
Section: misc
Priority: optional
Maintainer: Apex AI, Inc. <opensource@apex.ai>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gtest, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-launch, ros-galactic-launch-testing, ros-galactic-osrf-testing-tools-cpp, ros-galactic-rclcpp, ros-galactic-rmw-implementation-cmake, ros-galactic-rosidl-default-generators, ros-galactic-ros-workspace, ros-galactic-rmw-connext-cpp, ros-galactic-rmw-fastrtps-cpp, ros-galactic-rmw-implementation, ros-galactic-rmw-opensplice-cpp, ros-galactic-rosidl-typesupport-connext-c, ros-galactic-rosidl-typesupport-connext-cpp, ros-galactic-rosidl-typesupport-opensplice-c, ros-galactic-rosidl-typesupport-opensplice-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-performance-test
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-rclcpp, ros-galactic-rmw-implementation, ros-galactic-rosidl-default-runtime, ros-galactic-ros-workspace
Description: Tool to test performance of ROS2 and DDS data layers and communication.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-performance-test//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
